Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class JPasswordField

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.text.JTextComponent
                              |
                              +--javax.swing.JTextField
                                    |
                                    +--javax.swing.JPasswordField

All Implemented Interfaces:
  Accessible, ImageObserver, MenuContainer, Scrollable, Serializable, SwingConstants

public class JPasswordField
extends JTextField

`JPasswordField` is a lightweight component that allows the editing of a single line of text where the view indicates something was typed, but does not show the original characters. You can find further information and examples in How to Use Text Fields, a section in The Java Tutorial.

`JPasswordField` is intended to be source-compatible with `java.awt.TextField` used with `echoChar` set. It is provided separately to make it easier to safely change the UI for the `JTextField` without affecting password entries.

For the keyboard keys used by this component in the standard Look and Feel (L&F) renditions, see the JPasswordField key assignments.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeansTM has been added to the `java.beans` package. Please see `XMLEncoder`.

Nested Class Summary
`protected class` | `JPasswordField.AccessibleJPasswordField` This class implements accessibility support for the `JPasswordField` class.

Nested classes inherited from class javax.swing.JTextField
``

Nested classes inherited from class javax.swing.text.JTextComponent
`JTextComponent.KeyBinding`

Nested classes inherited from class javax.swing.JComponent
``

Nested classes inherited from class java.awt.Container
``

Nested classes inherited from class java.awt.Component
`Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary

Fields inherited from class javax.swing.JTextField
`notifyAction`

Fields inherited from class javax.swing.text.JTextComponent
`DEFAULT_KEYMAP, FOCUS_ACCELERATOR_KEY`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface javax.swing.SwingConstants
`BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`JPasswordField()` Constructs a new `JPasswordField`, with a default document, `null` starting text string, and 0 column width.
`JPasswordField(Document doc, String txt, int columns)` Constructs a new `JPasswordField` that uses the given text storage model and the given number of columns.
`JPasswordField(int columns)` Constructs a new empty `JPasswordField` with the specified number of columns.
`JPasswordField(String text)` Constructs a new `JPasswordField` initialized with the specified text.
`JPasswordField(String text, int columns)` Constructs a new `JPasswordField` initialized with the specified text and columns.

Method Summary
`void` | `copy()` Invokes `provideErrorFeedback` on the current look and feel, which typically initiates an error beep.
`void` | `cut()` Invokes `provideErrorFeedback` on the current look and feel, which typically initiates an error beep.
`boolean` | `echoCharIsSet()` Returns true if this `JPasswordField` has a character set for echoing.
`AccessibleContext` | `getAccessibleContext()` Returns the `AccessibleContext` associated with this `JPasswordField`.
`char` | `getEchoChar()` Returns the character to be used for echoing.
`char[]` | `getPassword()` Returns the text contained in this `TextComponent`.
`String` | `getText()` Deprecated. As of Java 2 platform v1.2, replaced by `getPassword`.
`String` | `getText(int offs, int len)` Deprecated. As of Java 2 platform v1.2, replaced by `getPassword`.
`String` | `getUIClassID()` Returns the name of the L&F class that renders this component.
`protected String` | `paramString()` Returns a string representation of this `JPasswordField`.
`void` | `setEchoChar(char c)` Sets the echo character for this `JPasswordField`.

Methods inherited from class javax.swing.JTextField
`addActionListener, configurePropertiesFromAction, createActionPropertyChangeListener, createDefaultModel, fireActionPerformed, getAction, getActionListeners, getActions, getColumns, getColumnWidth, getHorizontalAlignment, getHorizontalVisibility, getPreferredSize, getScrollOffset, isValidateRoot, postActionEvent, removeActionListener, scrollRectToVisible, setAction, setActionCommand, setColumns, setDocument, setFont, setHorizontalAlignment, setScrollOffset`

Methods inherited from class javax.swing.text.JTextComponent
`addCaretListener, addInputMethodListener, addKeymap, fireCaretUpdate, getCaret, getCaretColor, getCaretListeners, getCaretPosition, getDisabledTextColor, getDocument, getDragEnabled, getFocusAccelerator, getHighlighter, getInputMethodRequests, getKeymap, getKeymap, getMargin, getNavigationFilter, getPreferredScrollableViewportSize, getScrollableBlockIncrement, getScrollableTracksViewportHeight, getScrollableTracksViewportWidth, getScrollableUnitIncrement, getSelectedText, getSelectedTextColor, getSelectionColor, getSelectionEnd, getSelectionStart, getToolTipText, getUI, isEditable, loadKeymap, modelToView, moveCaretPosition, paste, processInputMethodEvent, read, removeCaretListener, removeKeymap, removeNotify, replaceSelection, select, selectAll, setCaret, setCaretColor, setCaretPosition, setComponentOrientation, setDisabledTextColor, setDragEnabled, setEditable, setFocusAccelerator, setHighlighter, setKeymap, setMargin, setNavigationFilter, setSelectedTextColor, setSelectionColor, setSelectionEnd, setSelectionStart, setText, setUI, updateUI, viewToModel, write`

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPropertyChangeListeners, getPropertyChangeListeners, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processMouseEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### JPasswordField

    public JPasswordField()

  Constructs a new `JPasswordField`, with a default document, `null` starting text string, and 0 column width.

### JPasswordField

    public JPasswordField(String text)

  Constructs a new `JPasswordField` initialized with the specified text. The document model is set to the default, and the number of columns to 0.

Parameters:
  `text` - the text to be displayed, `null` if none

### JPasswordField

    public JPasswordField(int columns)

  Constructs a new empty `JPasswordField` with the specified number of columns. A default model is created, and the initial string is set to `null`.

Parameters:
  `columns` - the number of columns >= 0

### JPasswordField

    public JPasswordField(String text,
                          int columns)

  Constructs a new `JPasswordField` initialized with the specified text and columns. The document model is set to the default.

Parameters:
  `text` - the text to be displayed, `null` if none
  `columns` - the number of columns >= 0

### JPasswordField

    public JPasswordField(Document doc,
                          String txt,
                          int columns)

  Constructs a new `JPasswordField` that uses the given text storage model and the given number of columns. This is the constructor through which the other constructors feed. The echo character is set to '*'. If the document model is `null`, a default one will be created.

Parameters:
  `doc` - the text storage to use
  `txt` - the text to be displayed, `null` if none
  `columns` - the number of columns to use to calculate the preferred width >= 0; if columns is set to zero, the preferred width will be whatever naturally results from the component implementation

Method Detail

### getUIClassID

    public String getUIClassID()

  Returns the name of the L&F class that renders this component.

  Overrides:
    `getUIClassID` in class `JTextField`
  Returns:
    the string "PasswordFieldUI"
  See Also:
    `JComponent.getUIClassID()`, `UIDefaults.getUI(javax.swing.JComponent)`

### getEchoChar

    public char getEchoChar()

  Returns the character to be used for echoing. The default is '*'.

  Returns:
    the echo character, 0 if unset
  See Also:
    `setEchoChar(char)`, `echoCharIsSet()`

### setEchoChar

    public void setEchoChar(char c)

  Sets the echo character for this `JPasswordField`. Note that this is largely a suggestion, since the view that gets installed can use whatever graphic techniques it desires to represent the field. Setting a value of 0 indicates that you wish to see the text as it is typed, similar to the behavior of a standard `JTextField`.

  Parameters:
    `c` - the echo character to display
  See Also:
    `echoCharIsSet()`, `getEchoChar()`

### echoCharIsSet

    public boolean echoCharIsSet()

  Returns true if this `JPasswordField` has a character set for echoing. A character is considered to be set if the echo character is not 0.

  Returns:
    true if a character is set for echoing
  See Also:
    `setEchoChar(char)`, `getEchoChar()`

### cut

    public void cut()

  Invokes `provideErrorFeedback` on the current look and feel, which typically initiates an error beep. The normal behavior of transferring the currently selected range in the associated text model to the system clipboard, and removing the contents from the model, is not acceptable for a password field.

  Overrides:
    `cut` in class `JTextComponent`
  See Also:
    `Toolkit.getSystemClipboard()`, `Clipboard`

### copy

    public void copy()

  Invokes `provideErrorFeedback` on the current look and feel, which typically initiates an error beep. The normal behavior of transferring the currently selected range in the associated text model to the system clipboard, and leaving the contents from the model, is not acceptable for a password field.

  Overrides:
    `copy` in class `JTextComponent`
  See Also:
    `Toolkit.getSystemClipboard()`, `Clipboard`

### getText

    public String getText()

  Deprecated. As of Java 2 platform v1.2, replaced by `getPassword`.

  Returns the text contained in this `TextComponent`. If the underlying document is `null`, will give a `NullPointerException`.

  For security reasons, this method is deprecated. Use the `* getPassword` method instead.

  Overrides:
    `getText` in class `JTextComponent`
  Returns:
    the text
  See Also:
    `JTextComponent.setText(java.lang.String)`

### getText

    public String getText(int offs,
                          int len)
                   throws BadLocationException

  Deprecated. As of Java 2 platform v1.2, replaced by `getPassword`.

  Fetches a portion of the text represented by the component. Returns an empty string if length is 0.

  For security reasons, this method is deprecated. Use the `getPassword` method instead.

  Overrides:
    `getText` in class `JTextComponent`
  Parameters:
    `offs` - the offset >= 0
    `len` - the length >= 0
  Returns:
    the text
  Throws:
    `BadLocationException` - if the offset or length are invalid

### getPassword

    public char[] getPassword()

  Returns the text contained in this `TextComponent`. If the underlying document is `null`, will give a `NullPointerException`. For stronger security, it is recommended that the returned character array be cleared after use by setting each character to zero.

  Returns:
    the text

### paramString

    protected String paramString()

  Returns a string representation of this `JPasswordField`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

  Overrides:
    `paramString` in class `JTextField`
  Returns:
    a string representation of this `JPasswordField`

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Returns the `AccessibleContext` associated with this `JPasswordField`. For password fields, the `AccessibleContext` takes the form of an `AccessibleJPasswordField`. A new `AccessibleJPasswordField` instance is created if necessary.

  Specified by:
    `getAccessibleContext` in interface `Accessible`
  Overrides:
    `getAccessibleContext` in class `JTextField`
  Returns:
    an `AccessibleJPasswordField` that serves as the `AccessibleContext` of this `JPasswordField`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.